'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

require('array.prototype.find');

function loadHTML(path) {
  return _cheerio2['default'].load(_fs2['default'].readFileSync(path, { encoding: 'UTF-8' })).html();
}

var ServerUtils = {

  loadEntries: function loadEntries(entries, staticFiles) {
    var entryPath = entries.path ? entries.path : staticFiles;

    // always fallback to index.html
    var defaultEntry = {
      '*': {
        regExp: null,
        html: loadHTML(_path2['default'].join(entryPath, 'index.html'))
      }
    };

    var routeEntries = Object.keys(entries.routes).reduce(function (result, route) {
      var entry = _path2['default'].join(entryPath, entries.routes[route]);
      result[route] = {
        regExp: (0, _pathToRegexp2['default'])(route),
        html: loadHTML(entry)
      };
      return result;
    }, {});

    return _extends({}, defaultEntry, routeEntries);
  },

  entryHTML: function entryHTML(entryFiles, req) {
    var entryPath = Object.keys(entryFiles).find(function (path) {
      if (path === '*') {
        return false;
      }
      return entryFiles[path].regExp.test(req.path);
    });

    // always fallback to index.html if route not matched
    if (entryPath) {
      return entryFiles[entryPath].html;
    } else {
      return entryFiles['*'].html;
    }
  }

};

exports['default'] = ServerUtils;
module.exports = exports['default'];